
module reset_cont(
    input           clk,        // 50MHz
    input           reset_n,    // system reset
    input           pll_locked, // H: locked, L: unlocked
    output          ins_reset_n // inside reset
);

//---------------------- internal signals ----------------------
    parameter   CNT_WIDTH = 8;
    reg [CNT_WIDTH-1:0] init_cnt;

//---------------------- logic description ----------------------
    always @(posedge clk or negedge reset_n) begin
        if(!reset_n)
            init_cnt <= 0;
        else if(!pll_locked)
            init_cnt <= 0;
        else if(!init_cnt[CNT_WIDTH-1])
            init_cnt <= init_cnt + 1'b1;
    end

    assign ins_reset_n = init_cnt[CNT_WIDTH-1];
    
endmodule
